Index: common/util.c
Prereq: 	10.11 
*** nvi-1.79/common/util.c	Mon Sep 16 04:57:58 1996
--- nvi-1.79-m17n/common/util.c	Thu Feb 20 00:41:49 1997
***************
*** 78,84 ****
--- 78,88 ----
  	recno_t lno;
  	size_t *cnop;
  {
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  	size_t cnt, len, off;
  	int isempty;
  
Index: curses/README.m17n
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/curses/README.m17n	Sun Feb 16 00:00:54 1997
***************
*** 0 ****
--- 1,55 ----
+ notes on curses multilingual patch
+ Jun-ichiro itojun Itoh <itojun@mt.cs.keio.ac.jp>
+ $Id: README.m17n,v 1.3 1997/02/15 15:00:54 itojun Exp $
+ 
+ 	The patched curses contained in this directory can easily be used
+ 	separately from nvi-m17n. (I've never tried, but I believe so)
+ 	So, I would like to add a brief description on the patch.
+ 
+ Programming interface
+ 	If called with addnstr() or waddnstr() with proper designation,
+ 	the package recognizes the following escape sequences:
+ 		ESC $ A		GB2312 mapped to G0
+ 		ESC $ B		JIS X0208-1983 mapped to G0
+ 		ESC $ @		JIS X0208-1976 mapped to G0
+ 		ESC ( x		any 94 charsets mapped to G0
+ 		ESC , x		any 96 charsets mapped to G0
+ 		ESC $ ( x	any 94-94 charsets mapped to G0
+ 		ESC $ , x	any 96-96 charsets mapped to G0
+ 				(There's no usage example so it may not work)
+ 	curses package will properly designate those charsets on redraw.
+ 
+ 	If some char passed by addnstr() or waddnstr() comes with 8th bit set
+ 	(0x80 - 0xff), it will be recognized as either:
+ 		two-byte 8bit sequence, or
+ 		single-byte 8bit sequence	if there's no more char
+ 	They will just go through curses.  It will be useful to implement
+ 	euc-jp/cn/kr, sjis, or big5 display.
+ 
+ 	The package does NOT hold designation status.  If you have no
+ 	designation in your argument to addnstr() or waddnstr(), it will be
+ 	considered as ASCII string.  You must re-designate each time you do
+ 	addnstr() or waddnstr().
+ 	For example,
+ 		addnstr(win, "\033$B", 3);
+ 		addnstr(win, "xx", 2);
+ 	will display "xx" in ASCII, not in JIS X0208-1983.
+ 
+ 	Example:
+ 		addnstr(win, "\033$Bxx", 5);	JIS X0208-1983 char
+ 		addnstr(win, "\033,Ax", 4);	latin-1 some char
+ 		addnstr(win, "\241\241", 2);	two-byte 8bit, go through
+ 		addnstr(win, "\241\041", 2);	two-byte 8bit, go through
+ 		addnstr(win, "\241", 1);	single-byte 8bit, go through
+ 
+ Requirement to terminal
+ 	A terminal software must properly handle G0 designation, if
+ 	you specified designation in parameter to addnstr() or waddnstr().
+ 
+ 	A terminal software must properly handle "ESC ( B" (ASCII charset to
+ 	G0), which will be frequently emitted by this curses package.
+ 
+ 	A terminal must be configured so that it can handle 8bit chars
+ 	emitted by programmers.  Since there's no way to find out what kind of
+ 	8bit encoding method is currently used, it is up to users to control
+ 	terminal encoding and the program's encoding.
Index: curses/addbytes.c
Prereq: 	8.4 
*** nvi-1.79/curses/addbytes.c	Thu Mar  7 06:54:43 1996
--- nvi-1.79-m17n/curses/addbytes.c	Thu Feb 20 12:49:10 1997
***************
*** 52,57 ****
--- 52,58 ----
  	register const char *bytes;
  	register int count;
  	int so;
+ #ifndef MULTIBYTE
  {
  	static char blanks[] = "        ";
  	register int c, newx, x, y;
***************
*** 157,159 ****
--- 158,432 ----
  	SYNCH_OUT;
  	return (OK);
  }
+ #else /*MULTIBYTE*/
+ {
+ 	static char blanks[] = "        ";
+ 	register int c, newx, x, y;
+ 	__LINE *lp;
+ 	__LDATA newch;
+ 	__LDATA newch0;
+ 	enum {ASCII, MB7, MB8} kstate;
+ 	char designation;
+ 	int is96;
+ 	int ismb;
+ 
+ 	/* initilize */
+ 	kstate = ASCII;
+ 	designation = '\0';
+ 	is96 = 0;
+ 	ismb = 0;
+ 
+ 	SYNCH_IN;
+ 
+ #ifdef CURSES_DEBUG
+ 	__CTRACE("ADDBYTES('%c') at (%d, %d)\n", c, y, x);
+ #endif
+ 	while (count--) {
+ 		c = *bytes++;
+ 		switch (c) {
+ 		case '\t':
+ 			SYNCH_OUT;
+ 			if (waddbytes(win, blanks, 8 - (x % 8)) == ERR)
+ 				return (ERR);
+ 			SYNCH_IN;
+ 			break;
+ 		case '\033':
+ 			if (2 <= count && bytes[0] == '(' && bytes[1] == 'B') {
+ 				designation = '\0';
+ 				count -= 2;
+ 				bytes += 2;
+ 				break;
+ 			} else if (2 <= count && strchr("(,", bytes[0])
+ 			    && 0x30 <= bytes[1] && bytes[1] <= 0x7f) {
+ 				designation = bytes[1];
+ 				is96 = (bytes[0] == ',');
+ 				ismb = 0;
+ 				count -= 2;
+ 				bytes += 2;
+ 				break;
+ 			} else if (2 <= count && bytes[0] == '$'
+ 			    && strchr("@AB", bytes[1])) {
+ 				designation = bytes[1];
+ 				is96 = 0;
+ 				ismb = 1;
+ 				count -= 2;
+ 				bytes += 2;
+ 				break;
+ 			} else if (3 <= count && bytes[0] == '$'
+ 			    && strchr("(,", bytes[1])
+ 			    && 0x30 <= bytes[2] && bytes[2] <= 0x7f) {
+ 				designation = bytes[2];
+ 				is96 = (bytes[1] == ',');
+ 				ismb = 1;
+ 				count -= 3;
+ 				bytes += 3;
+ 				break;
+ 			}
+ 			/* fall through */
+ 
+ 		default:
+ #ifdef CURSES_DEBUG
+ 	__CTRACE("ADDBYTES(%0.2o, %d, %d)\n", win, y, x);
+ #endif
+ 			
+ 			lp = win->lines[y];
+ 			if (lp->flags & __ISPASTEOL) {
+ 				lp->flags &= ~__ISPASTEOL;
+ newline:			if (y == win->maxy - 1) {
+ 					if (win->flags & __SCROLLOK) {
+ 						SYNCH_OUT;
+ 						scroll(win);
+ 						SYNCH_IN;
+ 						lp = win->lines[y];
+ 					        x = 0;
+ 					} else
+ 						return (ERR);
+ 				} else {
+ 					y++;
+ 					lp = win->lines[y];
+ 					x = 0;
+ 				}
+ 				if (c == '\n')
+ 					break;
+ 			}
+ 
+ #ifdef CURSES_DEBUG
+ 	__CTRACE("ADDBYTES: 1: y = %d, x = %d, firstch = %d, lastch = %d\n",
+ 	    y, x, *win->lines[y]->firstchp, *win->lines[y]->lastchp);
+ #endif
+ 
+ 			memcpy(&newch, &lp->line[x], __LDATASIZE);
+ 
+ 			/*
+ 			 * Create buffer for new character.
+ 			 */
+ 			newch.ch = c;
+ 			if (win->flags & __WSTANDOUT || so)
+ 				newch.attr |= __STANDOUT;
+ 			else
+ 				newch.attr &= ~__STANDOUT;
+ 			newch.attr &= ~(__MBFIRST | __MBSECOND | __MBDESIG  | __MB96);
+ 			newch.desig = '\0';
+ 			switch (kstate) {
+ 			case ASCII:
+ 				if (designation) {
+ 					newch.attr |= __MBDESIG;
+ 					newch.attr |= (is96 ? __MB96 : 0);
+ 					newch.desig = designation;
+ 					if (1 <= count && ismb) {
+ 						newch.attr |= __MBFIRST;
+ 						kstate = MB7;
+ 					}
+ 				} else if (c & 0x80) {
+ 					if (1 <= count) {
+ 						newch.attr |= __MBFIRST;
+ 						kstate = MB8;
+ 					}
+ 				}
+ 				break;
+ 			case MB7:
+ 				newch.attr |= __MBDESIG;
+ 				newch.attr |= (is96 ? __MB96 : 0);
+ 				newch.desig = designation;
+ 				/* fall through */
+ 			case MB8:
+ 				newch.attr |= __MBSECOND;
+ 				kstate = ASCII;
+ 				break;
+ 			}
+ 
+ 			/*
+ 			 * Displaying multibyte char across start-of-line
+ 			 * or end-of-line is illegal.  Protect ourself against
+ 			 * that situation.
+ 			 */
+ 			if (x == 0 && (newch.attr & __MBSECOND)) {
+ 				newch.ch = ' ';
+ 				newch.attr &= ~__MBALL;
+ 				newch.desig = '\0';
+ 			} else if (x == win->maxx - 1
+ 				&& (newch.attr & __MBFIRST)) {
+ 				newch.ch = ' ';
+ 				newch.attr &= ~__MBALL;
+ 				newch.desig = '\0';
+ 			}
+ 
+ #define	UPDATE(x)	\
+     {								\
+ 	newx = (x) + win->ch_off;				\
+ 	if (!(lp->flags & __ISDIRTY)) {				\
+ 		lp->flags |= __ISDIRTY;				\
+ 		*lp->firstchp = *lp->lastchp = newx;		\
+ 	} else if (newx < *lp->firstchp)			\
+ 		*lp->firstchp = newx;				\
+ 	else if (newx > *lp->lastchp)				\
+ 		*lp->lastchp = newx;				\
+     }
+ 
+ 			/*
+ 			 * Perform update, only if it is needed.
+ 			 *
+ 			 * 1. If we got first part of multibyte char,
+ 			 *    update will be delayed till the next round.
+ 			 * 2. If we got second part of multibyte char,
+ 			 *    and there is a change, update both part.
+ 			 * 3. If we got singlebyte char, and there is a change,
+ 			 *    update.
+ 			 *
+ 			 * While doing update, we might overwrite first/second
+ 			 * part of multibyte char only.  Since it is illegal
+ 			 * to do so, we'll erase the countarpart by space.
+ 			 */
+ 			if (newch.attr & __MBFIRST) {
+ 				/* update it later. */
+ 				memcpy(&newch0, &newch, __LDATASIZE);
+ 			} else if ((newch.attr & __MBSECOND)
+ 			 && (memcmp(&newch0, &lp->line[x - 1], __LDATASIZE)
+ 			  || memcmp(&newch, &lp->line[x], __LDATASIZE))) {
+ 				UPDATE(x - 1);
+ 				UPDATE(x);
+ 
+ 				if (0 <= x - 2
+ 				 && (lp->line[x-1].attr & __MBSECOND)) {
+ 					lp->line[x - 2].ch = ' ';
+ 					lp->line[x - 2].attr = 0;
+ 					lp->line[x - 2].desig = 0;
+ 
+ 					UPDATE(x - 2);
+ 				}
+ 				if (x + 1 < win->maxx
+ 				 && (lp->line[x].attr & __MBFIRST)) {
+ 					lp->line[x + 1].ch = ' ';
+ 					lp->line[x + 1].attr = 0;
+ 					lp->line[x + 1].desig = 0;
+ 
+ 					UPDATE(x + 1);
+ 				}
+ 
+ #ifdef CURSES_DEBUG
+ 	__CTRACE("ADDBYTES: change gives f/l: %d/%d [%d/%d]\n",
+ 	    *lp->firstchp, *lp->lastchp,
+ 	    *lp->firstchp - win->ch_off,
+ 	    *lp->lastchp - win->ch_off);
+ #endif
+ 
+ 				memcpy(&lp->line[x - 1], &newch0, __LDATASIZE);
+ 				memcpy(&lp->line[x], &newch, __LDATASIZE);
+ 			} else if (memcmp(&newch, &lp->line[x], __LDATASIZE)) {
+ 				UPDATE(x);
+ 
+ 				if (0 <= x - 1
+ 				 && (lp->line[x].attr & __MBSECOND)) {
+ 					lp->line[x - 1].ch = ' ';
+ 					lp->line[x - 1].attr = 0;
+ 					lp->line[x - 1].desig = 0;
+ 
+ 					UPDATE(x - 1);
+ 				}
+ 				if (x + 1 < win->maxx
+ 				 && (lp->line[x].attr & __MBFIRST)) {
+ 					lp->line[x + 1].ch = ' ';
+ 					lp->line[x + 1].attr = 0;
+ 					lp->line[x + 1].desig = 0;
+ 
+ 					UPDATE(x + 1);
+ 				}
+ 
+ #ifdef CURSES_DEBUG
+ 	__CTRACE("ADDBYTES: change gives f/l: %d/%d [%d/%d]\n",
+ 	    *lp->firstchp, *lp->lastchp,
+ 	    *lp->firstchp - win->ch_off,
+ 	    *lp->lastchp - win->ch_off);
+ #endif
+ 
+ 				memcpy(&lp->line[x], &newch, __LDATASIZE);
+ 			}
+ 			if (x == win->maxx - 1)
+ 				lp->flags |= __ISPASTEOL;
+ 			else
+ 				x++;
+ #ifdef CURSES_DEBUG
+ 	__CTRACE("ADDBYTES: 2: y = %d, x = %d, firstch = %d, lastch = %d\n",
+ 	    y, x, *win->lines[y]->firstchp, *win->lines[y]->lastchp);
+ #endif
+ 			break;
+ 		case '\n':
+ 			SYNCH_OUT;
+ 			wclrtoeol(win);
+ 			SYNCH_IN;
+ 			if (!NONL)
+ 				x = 0;
+ 			goto newline;
+ 		case '\r':
+ 			x = 0;
+ 			break;
+ 		case '\b':
+ 			if (--x < 0)
+ 				x = 0;
+ 			break;
+ 		}
+ 	}
+ 	SYNCH_OUT;
+ 	return (OK);
+ }
+ #endif /*MULTIBYTE*/
Index: curses/addch.c
Prereq: 	8.2 
*** nvi-1.79/curses/addch.c	Wed May  4 22:25:24 1994
--- nvi-1.79-m17n/curses/addch.c	Sun Feb  2 18:21:18 1997
***************
*** 51,56 ****
--- 51,59 ----
  
  	buf.ch = ch;
  	buf.attr = 0;
+ #ifdef MULTIBYTE
+ 	buf.desig = 0;
+ #endif
  	return (__waddch(win, &buf));
  }
  
Index: curses/box.c
Prereq: 	8.2 
*** nvi-1.79/curses/box.c	Wed May  4 22:25:24 1994
--- nvi-1.79-m17n/curses/box.c	Tue Feb  4 01:41:11 1997
***************
*** 56,77 ****
--- 56,114 ----
  	lp = win->lines[endy]->line;
  	for (i = 0; i < endx; i++) {
  		fp[i].ch = lp[i].ch = hor;
+ #ifndef MULTIBYTE
  		fp[i].attr &= ~__STANDOUT;
  		lp[i].attr &= ~__STANDOUT;
+ #else
+ 		fp[i].attr &= ~(__STANDOUT | __MBALL);
+ 		fp[i].desig = 0;
+ 		lp[i].attr &= ~(__STANDOUT | __MBALL);
+ 		lp[i].desig = 0;
+ #endif /*MULTIBYTE*/
  	}
  	endx--;
  	for (i = 0; i <= endy; i++) {
+ #ifndef MULTIBYTE
  		win->lines[i]->line[0].ch = vert;
  	        win->lines[i]->line[endx].ch = vert;
  		win->lines[i]->line[0].attr &= ~__STANDOUT;
  		win->lines[i]->line[endx].attr &= ~__STANDOUT;
+ #else
+ 		if (win->lines[i]->line[1].attr & __MBSECOND) {
+ 			win->lines[i]->line[1].ch = ' ';
+ 			win->lines[i]->line[1].attr &= ~(__STANDOUT | __MBALL);
+ 			win->lines[i]->line[1].desig = 0;
+ 		}
+ 		win->lines[i]->line[0].ch = vert;
+ 		win->lines[i]->line[0].attr &= ~(__STANDOUT | __MBALL);
+ 		win->lines[i]->line[0].desig = 0;
+ 		if (win->lines[i]->line[endx - 1].attr & __MBFIRST) {
+ 			win->lines[i]->line[endx - 1].ch = ' ';
+ 			win->lines[i]->line[endx - 1].attr &= ~(__STANDOUT | __MBALL);
+ 			win->lines[i]->line[endx - 1].desig = 0;
+ 		}
+ 	        win->lines[i]->line[endx].ch = vert;
+ 		win->lines[i]->line[endx].attr &= ~(__STANDOUT | __MBALL);
+ 		win->lines[i]->line[endx].desig = 0;
+ #endif /*MULTIBYTE*/
  	}
  	if (!(win->flags & __SCROLLOK) && (win->flags & __SCROLLWIN)) {
  		fp[0].ch = fp[endx].ch = lp[0].ch = lp[endx].ch = ' ';
+ #ifndef MULTIBYTE
  		fp[0].attr &= ~__STANDOUT;
  		fp[endx].attr &= ~__STANDOUT;
  		lp[0].attr &= ~__STANDOUT;
  		lp[endx].attr &= ~__STANDOUT;
+ #else
+ 		fp[0].attr &= ~(__STANDOUT | __MBALL);
+ 		fp[0].desig = 0;
+ 		fp[endx].attr &= ~(__STANDOUT | __MBALL);
+ 		fp[endx].desig = 0;
+ 		lp[0].attr &= ~(__STANDOUT | __MBALL);
+ 		lp[0].desig = 0;
+ 		lp[endx].attr &= ~(__STANDOUT | __MBALL);
+ 		lp[endx].desig = 0;
+ #endif /*MULTIBYTE*/
  	}
  	__touchwin(win);
  	return (OK);
Index: curses/clrtobot.c
Prereq: 	8.2 
*** nvi-1.79/curses/clrtobot.c	Wed May  4 22:25:25 1994
--- nvi-1.79-m17n/curses/clrtobot.c	Sun Feb  2 18:21:54 1997
***************
*** 65,70 ****
--- 65,73 ----
  					minx = sp - win->lines[y]->line;
  				sp->ch = ' ';
  				sp->attr = 0;
+ #ifdef MULTIBYTE
+ 				sp->desig = 0;
+ #endif
  			}
  		if (minx != -1)
  			__touchline(win, y, minx, maxx - win->lines[y]->line,
Index: curses/clrtoeol.c
Prereq: 	8.2 
*** nvi-1.79/curses/clrtoeol.c	Mon Feb 26 01:32:38 1996
--- nvi-1.79-m17n/curses/clrtoeol.c	Sun Feb  2 18:22:19 1997
***************
*** 67,72 ****
--- 67,75 ----
  				minx = sp - win->lines[y]->line;
  			sp->ch = ' ';
  			sp->attr = 0;
+ #ifdef MULTIBYTE
+ 			sp->desig = 0;
+ #endif
  		}
  #ifdef CURSES_DEBUG
  	__CTRACE("CLRTOEOL: minx = %d, maxx = %d, firstch = %d, lastch = %d\n",
Index: curses/cr_put.c
Prereq: 	8.3 
*** nvi-1.79/curses/cr_put.c	Mon Feb 26 01:32:41 1996
--- nvi-1.79-m17n/curses/cr_put.c	Sun Feb  2 18:21:42 1997
***************
*** 379,388 ****
--- 379,395 ----
  		}
  	}
  	while (outcol < destcol) {
+ #ifndef MULTIBYTE
  		/*
  		 * Move one char to the right.  We don't use ND space because
  		 * it's better to just print the char we are moving over.
  		 */
+ #else
+ 		/*
+ 		 * We use ND space since it is not possible to reprint
+ 		 * part of kanji chars.
+ 		 */
+ #endif /*MULTIBYTE*/
  		if (in_refresh)
  			if (plodflg)	/* Avoid a complex calculation. */
  				plodcnt--;
***************
*** 390,398 ****
  				i = curscr->lines[outline]->line[outcol].ch;
  				if ((curscr->lines[outline]->line[outcol].attr
  				     & __STANDOUT) ==
! 				    (curscr->flags & __WSTANDOUT))
  					putchar(i);
! 				else
  					goto nondes;
  			}
  		else
--- 397,412 ----
  				i = curscr->lines[outline]->line[outcol].ch;
  				if ((curscr->lines[outline]->line[outcol].attr
  				     & __STANDOUT) ==
! 				    (curscr->flags & __WSTANDOUT)) {
! #ifndef MULTIBYTE
  					putchar(i);
! #else
! 					if (ND)
! 						tputs(ND, 0, plodput);
! 					else
! 						putchar(i);
! #endif /*MULTIBYTE*/
! 				} else
  					goto nondes;
  			}
  		else
Index: curses/curses.h
Prereq: 	8.5 
*** nvi-1.79/curses/curses.h	Fri Jun 14 22:11:11 1996
--- nvi-1.79-m17n/curses/curses.h	Tue Feb  4 02:00:57 1997
***************
*** 120,126 ****
--- 120,134 ----
  	char ch;			/* the actual character */
  
  #define	__STANDOUT	0x01  		/* Added characters are standout. */
+ #define __MBFIRST	0x02		/* 94x94/96x96 first char */
+ #define __MBSECOND	0x04		/* 94x94/96x96 second char */
+ #define __MBDESIG	0x08		/* Need designation */
+ #define __MB96		0x10		/* 96/96x96 charset */
+ #define	__MBALL		0x1e
  	char attr;			/* attributes of character */
+ #ifdef MULTIBYTE
+ 	char desig;
+ #endif
  } __LDATA;
  
  #define __LDATASIZE	(sizeof(__LDATA))
***************
*** 235,242 ****
--- 243,255 ----
  	((bf) ? ((w)->flags |= __LEAVEOK) : ((w)->flags &= ~__LEAVEOK))
  #define	scrollok(w, bf) \
  	((bf) ? ((w)->flags |= __SCROLLOK) : ((w)->flags &= ~__SCROLLOK))
+ #ifndef MULTIBYTE
  #define	winch(w) \
  	((w)->lines[(w)->cury]->line[(w)->curx].ch & 0177)
+ #else
+ #define	winch(w) \
+ 	((w)->lines[(w)->cury]->line[(w)->curx].ch)
+ #endif /*MULTIBYTE*/
  
  /* Public function prototypes. */
  int	 box();
Index: curses/delch.c
Prereq: 	8.2 
*** nvi-1.79/curses/delch.c	Wed May  4 22:25:26 1994
--- nvi-1.79-m17n/curses/delch.c	Sun Feb  2 18:22:35 1997
***************
*** 58,63 ****
--- 58,66 ----
  	}
  	temp1->ch = ' ';
  	temp1->attr = 0;
+ #ifdef MULTIBYTE
+ 	temp1->desig = 0;
+ #endif
  	__touchline(win, win->cury, win->curx, win->maxx - 1, 0);
  	return (OK);
  }
Index: curses/deleteln.c
Prereq: 	8.2 
*** nvi-1.79/curses/deleteln.c	Mon Feb 26 01:32:47 1996
--- nvi-1.79-m17n/curses/deleteln.c	Sun Feb  2 18:22:50 1997
***************
*** 74,79 ****
--- 74,82 ----
  	for(i = 0; i < win->maxx; i++) {
  		temp->line[i].ch = ' ';
  		temp->line[i].attr = 0;
+ #ifdef MULTIBYTE
+ 		temp->line[i].desig = 0;
+ #endif
  	}
  	__touchline(win, y, 0, win->maxx - 1, 0);
  	if (win->orig == NULL)
Index: curses/erase.c
Prereq: 	8.2 
*** nvi-1.79/curses/erase.c	Mon Feb 26 01:32:50 1996
--- nvi-1.79-m17n/curses/erase.c	Sun Feb  2 18:23:15 1997
***************
*** 63,68 ****
--- 63,71 ----
  					minx = sp - start;
  				sp->ch = ' ';
  				sp->attr = 0;
+ #ifdef MULTIBYTE
+ 				sp->desig = 0;
+ #endif
  			}
  		if (minx != -1)
  			__touchline(win, y, minx, maxx - win->lines[y]->line,
Index: curses/insch.c
Prereq: 	8.2 
*** nvi-1.79/curses/insch.c	Wed May  4 22:25:27 1994
--- nvi-1.79-m17n/curses/insch.c	Tue Feb  4 01:44:15 1997
***************
*** 54,65 ****
--- 54,90 ----
  	end = &win->lines[win->cury]->line[win->curx];
  	temp1 = &win->lines[win->cury]->line[win->maxx - 1];
  	temp2 = temp1 - 1;
+ #ifdef MULTIBYTE
+ 	if (end->attr & __MBSECOND) {
+ 		if (1 < win->curx) {
+ 			(end - 1)->ch = ' ';
+ 			(end - 1)->attr &= ~__MBALL;
+ 			(end - 1)->desig = 0;
+ 		}
+ 		end->ch = ' ';
+ 		end->attr &= ~__MBALL;
+ 		end->desig = 0;
+ 	}
+ 	if (temp2->attr & __MBFIRST) {
+ 		temp2->ch = ' ';
+ 		temp2->attr &= ~__MBALL;
+ 		temp2->desig = 0;
+ 		temp1->ch = ' ';
+ 		temp1->attr &= ~__MBALL;
+ 		temp1->desig = 0;
+ 	}
+ #endif /*MULTIBYTE*/
  	while (temp1 > end) {
  		(void)memcpy(temp1, temp2, sizeof(__LDATA));
  		temp1--, temp2--;
  	}
  	temp1->ch = ch;
+ #ifndef MULTIBYTE
  	temp1->attr &= ~__STANDOUT;
+ #else
+ 	temp1->attr &= ~(__STANDOUT | __MBALL);
+ 	temp1->desig = 0;
+ #endif
  	__touchline(win, win->cury, win->curx, win->maxx - 1, 0);
  	if (win->cury == LINES - 1 && 
  	    (win->lines[LINES - 1]->line[COLS - 1].ch != ' ' ||
Index: curses/insertln.c
Prereq: 	8.2 
*** nvi-1.79/curses/insertln.c	Mon Feb 26 01:32:59 1996
--- nvi-1.79-m17n/curses/insertln.c	Sun Feb  2 18:23:33 1997
***************
*** 74,79 ****
--- 74,82 ----
  	for(i = 0; i < win->maxx; i++) {
  		temp->line[i].ch = ' ';
  		temp->line[i].attr = 0;
+ #ifdef MULTIBYTE
+ 		temp->line[i].desig = 0;
+ #endif
  	}
  	__touchline(win, y, 0, win->maxx - 1, 0);
  	if (win->orig == NULL)
Index: curses/newwin.c
Prereq: 	8.3 
*** nvi-1.79/curses/newwin.c	Mon Feb 26 01:33:09 1996
--- nvi-1.79-m17n/curses/newwin.c	Sun Feb  2 18:21:48 1997
***************
*** 80,85 ****
--- 80,88 ----
  		for (sp = lp->line, j = 0; j < nc; j++, sp++) {
  			sp->ch = ' ';
  			sp->attr = 0;
+ #ifdef MULTIBYTE
+ 			sp->desig = 0;
+ #endif
  		}
  		lp->hash = __hash((char *) lp->line, nc * __LDATASIZE);
  	}
Index: curses/overlay.c
Prereq: 	8.2 
*** nvi-1.79/curses/overlay.c	Mon Feb 26 01:33:13 1996
--- nvi-1.79-m17n/curses/overlay.c	Thu Feb 20 12:41:12 1997
***************
*** 71,77 ****
  		x = startx - win2->begx;
  		for (sp = &win1->lines[y1]->line[startx - win1->begx]; 
  		     sp < end; sp++) {
! 			if (!isspace(sp->ch)) {
  				wmove(win2, y2, x);
  				__waddch(win2, sp);
  			}
--- 71,82 ----
  		x = startx - win2->begx;
  		for (sp = &win1->lines[y1]->line[startx - win1->begx]; 
  		     sp < end; sp++) {
! #ifndef MULTIBYTE
! 			if (!isspace(sp->ch))
! #else
! 			if (!isspace(sp->ch & 0xff))
! #endif
! 			{
  				wmove(win2, y2, x);
  				__waddch(win2, sp);
  			}
Index: curses/refresh.c
Prereq: 	8.7 
*** nvi-1.79/curses/refresh.c	Sat Mar 16 00:49:32 1996
--- nvi-1.79-m17n/curses/refresh.c	Thu Feb 20 12:49:51 1997
***************
*** 47,52 ****
--- 47,96 ----
  static void	quickch();
  static void	scrolln();
  
+ #ifdef MULTIBYTE
+ static void
+ putdesig(csp)
+ 	__LDATA *csp;
+ {
+ 	static enum { NO, ASCII, CACHED } prevstate = NO;
+ 	static __LDATA prev;
+ 
+ 	if (csp == NULL)
+ 		goto ascii;
+ 
+ 	if ((csp->attr & __MBDESIG) && csp->desig) {
+ 		if (prevstate == CACHED) {
+ 			if (csp && prev.attr == csp->attr
+ 			&& prev.desig == csp->desig)
+ 				return;
+ 		}
+ 
+ 		putchar('\033');
+ 		if (csp->attr & __MBFIRST) {
+ 			putchar('$');
+ 			if (!strchr("@AB", csp->desig))
+ 				putchar((csp->attr & __MB96) ? ',' : '(');
+ 			putchar(csp->desig);
+ 		} else {
+ 			putchar((csp->attr & __MB96) ? ',' : '(');
+ 			putchar(csp->desig);
+ 		}
+ 
+ 		prev = *csp;
+ 		prevstate = CACHED;
+ 	} else {
+ ascii:
+ 		if (prevstate == ASCII)
+ 			return;
+ 
+ 		putchar('\033');
+ 		putchar('(');
+ 		putchar('B');
+ 		prevstate = ASCII;
+ 	}
+ }
+ #endif /*MULTIBYTE*/
+ 
  /*
   * wrefresh --
   *	Make the current screen look like "win" over the area coverd by
***************
*** 272,290 ****
  	}
  
  	while (wx <= lch) {
! 		if (!force && memcmp(nsp, csp, sizeof(__LDATA)) == 0) {
  			if (wx <= lch) {
  				while (wx <= lch &&
! 				    memcmp(nsp, csp, sizeof(__LDATA)) == 0) {
  					nsp++;
  					if (!curwin)
  						++csp;
  					++wx;
  				}
  				continue;
  			}
  			break;
  		}
  		domvcur(ly, lx, y, wx + win->begx);
  
  #ifdef CURSES_DEBUG
--- 316,364 ----
  	}
  
  	while (wx <= lch) {
! #ifndef MULTIBYTE
! 		if (!force && memcmp(nsp, csp, sizeof(__LDATA)) == 0)
! #else
! 		if (!force && memcmp(nsp, csp,
! 			((nsp->attr & __MBFIRST) ? 2 : 1) * sizeof(__LDATA)) == 0)
! #endif /*MULTIBYTE*/
! 		{
  			if (wx <= lch) {
+ #ifndef MULTIBYTE
  				while (wx <= lch &&
! 				    memcmp(nsp, csp, sizeof(__LDATA)) == 0)
! #else
! 				while (wx <= lch &&
! 				    memcmp(nsp, csp,
! 					((nsp->attr & __MBFIRST) ? 2 : 1) * sizeof(__LDATA)) == 0)
! #endif /*MULTIBYTE*/
! 				{
! #ifndef MULTIBYTE
  					nsp++;
  					if (!curwin)
  						++csp;
  					++wx;
+ #else
+ 					if (nsp->attr & __MBFIRST) {
+ 						nsp += 2;
+ 						if (!curwin)
+ 							csp += 2;
+ 						wx += 2;
+ 					} else {
+ 						nsp++;
+ 						if (!curwin)
+ 							++csp;
+ 						++wx;
+ 					}
+ #endif /*MULTIBYTE*/
  				}
  				continue;
  			}
  			break;
  		}
+ #ifdef MULTIBYTE
+ 		putdesig(NULL);
+ #endif
  		domvcur(ly, lx, y, wx + win->begx);
  
  #ifdef CURSES_DEBUG
***************
*** 293,300 ****
  #endif
  		ly = y;
  		lx = wx + win->begx;
  		while (wx <= lch &&
! 		    (force || memcmp(nsp, csp, sizeof(__LDATA)) != 0)) {
  
  			if (ce != NULL &&
  			    win->maxx + win->begx == curscr->maxx &&
--- 367,381 ----
  #endif
  		ly = y;
  		lx = wx + win->begx;
+ #ifndef MULTIBYTE
  		while (wx <= lch &&
! 		    (force || memcmp(nsp, csp, sizeof(__LDATA)) != 0))
! #else
! 		while (wx <= lch &&
! 		    (force || memcmp(nsp, csp,
! 			((nsp->attr & __MBFIRST) ? 2 : 1) * sizeof(__LDATA)) != 0))
! #endif /*MULTIBYTE*/
! 		{
  
  			if (ce != NULL &&
  			    win->maxx + win->begx == curscr->maxx &&
***************
*** 312,317 ****
--- 393,401 ----
  				if ((clsp - nlsp >= strlen(CE)
  				    && clsp < win->maxx * __LDATASIZE) ||
  				    wy == win->maxy - 1) {
+ #ifdef MULTIBYTE
+ 					putdesig(NULL);
+ #endif
  					if (curscr->flags & __WSTANDOUT) {
  						tputs(SE, 0, __cputchar);
  						curscr->flags &= ~__WSTANDOUT;
***************
*** 321,326 ****
--- 405,413 ----
  					while (wx++ <= clsp) {
  						csp->ch = ' ';
  						csp->attr = 0;
+ #ifdef MULTIBYTE
+ 						csp->desig = 0;
+ #endif
  						csp++;
  					}
  					return (OK);
***************
*** 336,352 ****
--- 423,452 ----
  			if (nsp->attr & __STANDOUT) {
  				if (!(curscr->flags & __WSTANDOUT) &&
  				    SO != NULL && SE != NULL) {
+ #ifdef MULTIBYTE
+ 					putdesig(NULL);
+ #endif
  					tputs(SO, 0, __cputchar);
  					curscr->flags |= __WSTANDOUT;
  				}
  			} else
  				if (curscr->flags & __WSTANDOUT &&
  				    SE != NULL) {
+ #ifdef MULTIBYTE
+ 					putdesig(NULL);
+ #endif
  					tputs(SE, 0, __cputchar);
  					curscr->flags &= ~__WSTANDOUT;
  				}
  
+ #ifndef MULTIBYTE
  			wx++;
+ #else
+ 			if (nsp->attr & __MBFIRST)
+ 				wx += 2;
+ 			else
+ 				wx++;
+ #endif /*MULTIBYTE*/
  			if (wx >= win->maxx && wy == win->maxy - 1 && !curwin)
  				if (win->flags & __SCROLLOK) {
  					if (curscr->flags & __WSTANDOUT
***************
*** 359,395 ****
--- 459,567 ----
  						}
  					if (!(win->flags & __SCROLLWIN)) {
  						if (!curwin) {
+ #ifndef MULTIBYTE
  							csp->attr = nsp->attr;
  							putchar(csp->ch = nsp->ch);
+ #else
+ 							putdesig(nsp);
+ 							if (nsp->attr & __MBFIRST) {
+ 								csp->attr = nsp->attr;
+ 								csp->desig = nsp->desig;
+ 								putchar(csp->ch = nsp->ch);
+ 								(csp+1)->attr = (nsp+1)->attr;
+ 								(csp+1)->desig = (nsp+1)->desig;
+ 								putchar((csp+1)->ch = (nsp+1)->ch);
+ 							} else {
+ 								csp->attr = nsp->attr;
+ 								csp->desig = nsp->desig;
+ 								putchar(csp->ch = nsp->ch);
+ 							}
+ #endif /*MULTIBYTE*/
  						} else
+ #ifndef MULTIBYTE
  							putchar(nsp->ch);
+ #else
+ 						{
+ 							putdesig(nsp);
+ 							if (nsp->attr & __MBFIRST) {
+ 								putchar(nsp->ch);
+ 								putchar((nsp+1)->ch);
+ 							} else
+ 								putchar(nsp->ch);
+ 						}
+ #endif /*MULTIBYTE*/
  					}
  					if (wx + win->begx < curscr->maxx) {
+ #ifdef MULTIBYTE
+ 						putdesig(NULL);
+ #endif
  						domvcur(ly, wx + win->begx,
  						    win->begy + win->maxy - 1,
  						    win->begx + win->maxx - 1);
  					}
  					ly = win->begy + win->maxy - 1;
  					lx = win->begx + win->maxx - 1;
+ #ifdef MULTIBYTE
+ 					putdesig(NULL);
+ #endif
  					return (OK);
  				}
  			if (wx < win->maxx || wy < win->maxy - 1 ||
  			    !(win->flags & __SCROLLWIN)) {
  				if (!curwin) {
+ #ifndef MULTIBYTE
  					csp->attr = nsp->attr;
  					putchar(csp->ch = nsp->ch);
  					csp++;
+ #else
+ 					putdesig(nsp);
+ 					if (nsp->attr & __MBFIRST) {
+ 						csp->attr = nsp->attr;
+ 						csp->desig = nsp->desig;
+ 						putchar(csp->ch = nsp->ch);
+ 						(csp+1)->attr = (nsp+1)->attr;
+ 						(csp+1)->desig = (nsp+1)->desig;
+ 						putchar((csp+1)->ch = (nsp+1)->ch);
+ 						csp += 2;
+ 					} else {
+ 						csp->attr = nsp->attr;
+ 						csp->desig = nsp->desig;
+ 						putchar(csp->ch = nsp->ch);
+ 						csp++;
+ 					}
+ #endif /*MULTIBYTE*/
  				} else
+ #ifndef MULTIBYTE
  					putchar(nsp->ch);
+ #else
+ 				{
+ 					putdesig(nsp);
+ 					if (nsp->attr & __MBFIRST) {
+ 						putchar(nsp->ch);
+ 						putchar((nsp+1)->ch);
+ 					} else
+ 						putchar(nsp->ch);
+ 				}
+ #endif /*MULTIBYTE*/
  			}
  #ifdef CURSES_DEBUG
  			__CTRACE("makech: putchar(%c)\n", nsp->ch & 0177);
  #endif
  			if (UC && (nsp->attr & __STANDOUT)) {
+ #ifdef MULTIBYTE
+ 				putdesig(NULL);
+ #endif
  				putchar('\b');
  				tputs(UC, 0, __cputchar);
  			}
+ #ifndef MULTIBYTE
  			nsp++;
+ #else
+ 			if (nsp->attr & __MBFIRST)
+ 				nsp += 2;
+ 			else
+ 				nsp++;
+ #endif /*MULTIBYTE*/
  #ifdef CURSES_DEBUG
  		__CTRACE("makech: 2: wx = %d, lx = %d\n", wx, lx);
  #endif
***************
*** 400,405 ****
--- 572,580 ----
  		if (lx >= COLS && AM)
  			lx = COLS - 1;
  		else if (wx >= win->maxx) {
+ #ifdef MULTIBYTE
+ 			putdesig(NULL);
+ #endif
  			domvcur(ly, lx, ly, win->maxx + win->begx - 1);
  			lx = win->maxx + win->begx - 1;
  		}
***************
*** 410,415 ****
--- 585,593 ----
  	}
  
  	/* Don't leave the screen in standout mode. */
+ #ifdef MULTIBYTE
+ 	putdesig(NULL);
+ #endif
  	if (curscr->flags & __WSTANDOUT) {
  		tputs(SE, 0, __cputchar);
  		curscr->flags &= ~__WSTANDOUT;
***************
*** 568,573 ****
--- 746,754 ----
  	for (i = 0; i < win->maxx; i++) {
  		buf[i].ch = ' ';
  		buf[i].attr = 0;
+ #ifdef MULTIBYTE
+ 		buf[i].desig = 0;
+ #endif
  	}
  	blank_hash = __hash((char *) buf, win->maxx * __LDATASIZE);
  
